"""
    Lethean VPN

    Distributed Virtual Private Marketplace  # noqa: E501

    The version of the OpenAPI document: 1.1.1
    Contact: contact@lethean.io
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from lethean.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from lethean.exceptions import ApiAttributeError


def lazy_import():
    from lethean.model.certificates_entity import CertificatesEntity
    from lethean.model.proxy_settings_entity import ProxySettingsEntity
    from lethean.model.time_range_entity import TimeRangeEntity
    from lethean.model.vpn_settings_entity import VpnSettingsEntity
    globals()['CertificatesEntity'] = CertificatesEntity
    globals()['ProxySettingsEntity'] = ProxySettingsEntity
    globals()['TimeRangeEntity'] = TimeRangeEntity
    globals()['VpnSettingsEntity'] = VpnSettingsEntity


class ServiceEntity(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'VPN': "vpn",
            'PROXY': "proxy",
        },
    }

    validations = {
        ('id',): {
            'max_length': 2,
            'min_length': 2,
            'regex': {
                'pattern': r'[0-9A-F]{1}[0-9A-F]{1}',  # noqa: E501
            },
        },
        ('name',): {
            'max_length': 32,
            'regex': {
                'pattern': r'^[a-zA-Z0-9 ,.-_]+$',  # noqa: E501
            },
        },
        ('cost',): {
            'max_length': 14,
            'regex': {
                'pattern': r'([0-9]{1,5}|[.]{1}[0-9]{1,8})',  # noqa: E501
            },
        },
        ('download_speed',): {
            'inclusive_maximum': 99999999999,
            'inclusive_minimum': 0,
        },
        ('upload_speed',): {
            'inclusive_maximum': 99999999999,
            'inclusive_minimum': 0,
        },
        ('first_pre_paid_minutes',): {
            'inclusive_maximum': 1440,
            'inclusive_minimum': 10,
        },
        ('first_verifications_needed',): {
            'inclusive_maximum': 2,
            'inclusive_minimum': 0,
        },
        ('subsequent_pre_paid_minutes',): {
            'inclusive_maximum': 1440,
            'inclusive_minimum': 10,
        },
        ('subsequent_verifications_needed',): {
            'inclusive_maximum': 1,
            'inclusive_minimum': 0,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'cost': (str,),  # noqa: E501
            'download_speed': (float,),  # noqa: E501
            'upload_speed': (float,),  # noqa: E501
            'disable': (bool,),  # noqa: E501
            'first_pre_paid_minutes': (float,),  # noqa: E501
            'first_verifications_needed': (float,),  # noqa: E501
            'subsequent_pre_paid_minutes': (float,),  # noqa: E501
            'subsequent_verifications_needed': (float,),  # noqa: E501
            'allow_refunds': (bool,),  # noqa: E501
            'proxy': ([ProxySettingsEntity],),  # noqa: E501
            'vpn': ([VpnSettingsEntity],),  # noqa: E501
            'validity': (TimeRangeEntity,),  # noqa: E501
            'certificates': ([CertificatesEntity],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'type': 'type',  # noqa: E501
        'cost': 'cost',  # noqa: E501
        'download_speed': 'downloadSpeed',  # noqa: E501
        'upload_speed': 'uploadSpeed',  # noqa: E501
        'disable': 'disable',  # noqa: E501
        'first_pre_paid_minutes': 'firstPrePaidMinutes',  # noqa: E501
        'first_verifications_needed': 'firstVerificationsNeeded',  # noqa: E501
        'subsequent_pre_paid_minutes': 'subsequentPrePaidMinutes',  # noqa: E501
        'subsequent_verifications_needed': 'subsequentVerificationsNeeded',  # noqa: E501
        'allow_refunds': 'allowRefunds',  # noqa: E501
        'proxy': 'proxy',  # noqa: E501
        'vpn': 'vpn',  # noqa: E501
        'validity': 'validity',  # noqa: E501
        'certificates': 'certificates',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, name, type, cost, download_speed, upload_speed, disable, *args, **kwargs):  # noqa: E501
        """ServiceEntity - a model defined in OpenAPI

        Args:
            id (str): ID of the service
            name (str): Name of the service
            type (str): Type of the service
            cost (str): Per minute Cost of the service
            download_speed (float): Service download speed in Mbits
            upload_speed (float): Service upload speed in Mbits
            disable (bool): disable or not the service

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            first_pre_paid_minutes (float): Amount of pre-paid minutes for first payment. [optional]  # noqa: E501
            first_verifications_needed (float): Number of verifications needed for first payment. [optional]  # noqa: E501
            subsequent_pre_paid_minutes (float): Amount of pre-paid minutes for subsequent payments. [optional]  # noqa: E501
            subsequent_verifications_needed (float): Number of verifications needed for subsequent payments. [optional]  # noqa: E501
            allow_refunds (bool): Whether or not refunds are allowed. [optional]  # noqa: E501
            proxy ([ProxySettingsEntity]): array containing Proxy related settings. only available if service is of type proxy, null otherwise. [optional]  # noqa: E501
            vpn ([VpnSettingsEntity]): array containing VPN related settings. only available if service is of type vpn, null otherwise. [optional]  # noqa: E501
            validity (TimeRangeEntity): [optional]  # noqa: E501
            certificates ([CertificatesEntity]): inside each service, there should be a field named certificates that has a list of IDs, referencing the certificates at the provider level.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.name = name
        self.type = type
        self.cost = cost
        self.download_speed = download_speed
        self.upload_speed = upload_speed
        self.disable = disable
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, name, type, cost, download_speed, upload_speed, disable, *args, **kwargs):  # noqa: E501
        """ServiceEntity - a model defined in OpenAPI

        Args:
            id (str): ID of the service
            name (str): Name of the service
            type (str): Type of the service
            cost (str): Per minute Cost of the service
            download_speed (float): Service download speed in Mbits
            upload_speed (float): Service upload speed in Mbits
            disable (bool): disable or not the service

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            first_pre_paid_minutes (float): Amount of pre-paid minutes for first payment. [optional]  # noqa: E501
            first_verifications_needed (float): Number of verifications needed for first payment. [optional]  # noqa: E501
            subsequent_pre_paid_minutes (float): Amount of pre-paid minutes for subsequent payments. [optional]  # noqa: E501
            subsequent_verifications_needed (float): Number of verifications needed for subsequent payments. [optional]  # noqa: E501
            allow_refunds (bool): Whether or not refunds are allowed. [optional]  # noqa: E501
            proxy ([ProxySettingsEntity]): array containing Proxy related settings. only available if service is of type proxy, null otherwise. [optional]  # noqa: E501
            vpn ([VpnSettingsEntity]): array containing VPN related settings. only available if service is of type vpn, null otherwise. [optional]  # noqa: E501
            validity (TimeRangeEntity): [optional]  # noqa: E501
            certificates ([CertificatesEntity]): inside each service, there should be a field named certificates that has a list of IDs, referencing the certificates at the provider level.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.name = name
        self.type = type
        self.cost = cost
        self.download_speed = download_speed
        self.upload_speed = upload_speed
        self.disable = disable
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
